const readline = require('readline');
const xserver = process.argv[2] ? process.argv[2] : "http://localhost:3000";

// Apenas para fins de teste
const rl = readline.createInterface({
    input: process.stdin,
    output: process.stdout,
    prompt: 'Log CLI> '
})


const client = require("socket.io-client")(xserver, {
    "rejectUnauthorized": false
})

client.on('connect', () => {
    console.log('Parece que conectou')

    client.emit('login_api', { user: 'admin' }, resposta => {
        console.log(`Login resposta: ${JSON.stringify(resposta)}`)
        if (resposta.error) {
            console.log(`Verifique os dados de acesso`)
        }
        else {
            // Login ok
            console.log('Dae sim...logado')
            console.log('Digite "sair" ou "q" para sair')
            console.log('Digite "log set LEVEL" para mudar o nivel de log, levels aceitos: error, warn, info, debug')
            rl.prompt()
        }
    });
});

rl.on('line', (line) => {
    let pars = line.trim().split(' ');

    switch (pars[0]) {
        case 'sair':
        case 'quit':
        case 'q':
            rl.close();
            break;
        case 'log':
            if (pars.length < 3) {
                console.log('Uso: log set LEVEL')
                break;
            }
            let level = pars[2]
            if (['error', 'warn', 'info', 'debug'].includes(level)) {
                client.emit('setLogLevel', { level }, resposta => {
                    console.log(`Resposta: ${resposta}`)
                })
            } else {
                console.log(`Invalid level: ${level}`)
            }
            break
        case '':
            break;
        default:
            break;
    }
    rl.prompt()
}).on('close', () => {
    console.log('Até logo!');
    process.exit(0);
});