/**
 * App para gravar todos os eventos gerados no AMI em log
 */

function logRotateConfig() {
    let logrotate = `
    /var/log/xcontact-ami-eventos.log {
        daily
        missingok
        rotate 7
        compress
        delaycompress
        create 640 root root
    }
    `
    fs = require('fs')
    fs.writeFile('/etc/logrotate.d/xcontact-ami-eventos', logrotate, function (err) {
        if (err) return console.log(err)
        console.log('Logrotate configurado')
    })
}

//logRotateConfig()

const client = require("socket.io-client")('http://localhost:3000', {
    "rejectUnauthorized": false
})

client.on('connect', () => {
    console.log('Parece que conectou')

    client.emit('login_api', { nome: 'admin', senha: 'admin' }, resposta => {
        console.log(`Login resposta: ${JSON.stringify(resposta)}`)
        if (resposta.error) {
            console.log(`Verifique os dados de acesso`)
        }
        else {
            // Login ok
            console.log('Dae sim...logado')
        }
    })
})

const EventosBroadCast = [
    'FilaAtualizada',
    'FilaRemovida',
    'FilaLigacaoAdicionada',
    'FilaLigacaoAtendida',
    'FilaLigacaoAbandonou',
    'FilaLigacaoTransbordou',
    'FilaLigacaoTerminou',
    'AgenteAdicionado',
    'AgenteRemovido',
    'AgenteStatus',
    'AgenteLigacao',
    'FilaAdicionadaAgente',
    'FilaRemovidaAgente',
    'TransferenciaDireta',
    'TransferenciaConsulta'
]

EventosBroadCast.forEach(event => {
    console.log(`Monitorando evento: ${event}`)
    client.on(`${event}`, dados => {
        console.log(`Evento: ${event} - ${JSON.stringify(dados)}`)
    })
})